type attr = string * string

and xattr = string * action

and decl =
  | Encoding of string
  | Namespace of string * string
  | Template of attr list * action list
  | DefTemplate of attr list * xattr list * action list
  | Output of attr list
  | Variable of string * action
  | Mode of string * decl list
  | Macro of string * xattr list * action
  
and action =
  | String of string
  | QString of string
  | Node of string * attr list * action list
  | NodeStart of string * attr list
  | NodeEnd of string
  | ValueOf of string
  | Entity of string
  | CallTemplate of string * xattr list
  | Container of action list
  | Eval of string
  | Apply of attr list
  | CallMacro of string * xattr list
  | MacroArg of string
  | Redirect of attr list * action
  | If of attr list * action
  | IfElse of attr list * action * action
  | ForEach of attr list * action
  | Choose of attr list * when_clause list
  | AVariable of string * action

and when_clause =
  | When of attr list * action
  | Otherwise of attr list * action
