let main () =
  let b = Buffer.create 1000 in
  let rec rd ch =
    try
      Buffer.add_string b (input_line ch);
      Buffer.add_char b '\n';
      rd ch
    with End_of_file -> () in
  let _ = 
    if Array.length Sys.argv != 2 then begin
      prerr_endline ("USAGE: " ^ Sys.argv.(0) ^ " file.xspp");
      exit 1
    end in
  let filename = Sys.argv.(1) in
  let ch = open_in filename in
  let _ = rd ch in
  let prog = Gram.parse filename (Buffer.contents b) in
  let _ = Sementics.compile prog stdout in
  exit 0

let _ = main ()
